function SimpleBar:InitTextures()
    MainMenuBarPageNumber:Hide();
    ActionBarUpButton:Hide();
    ActionBarDownButton:Hide();

    UpdateTalentButton = function() return; end	

    MainMenuXPBarTexture2:Hide();
    MainMenuXPBarTexture3:Hide();
    MainMenuBarTexture2:Hide();
    MainMenuBarTexture3:Hide();
    MainMenuMaxLevelBar2:Hide();
    MainMenuMaxLevelBar3:Hide();
    ReputationWatchBarTexture2:SetTexture("");
    ReputationWatchBarTexture3:SetTexture("");
    ReputationXPBarTexture2:SetTexture("");
    ReputationXPBarTexture3:SetTexture("");

    ShapeshiftBarRight:Hide();

    MainMenuBar:SetWidth(512);
    MainMenuExpBar:SetWidth(512);
    ReputationWatchBar:SetWidth(512);
    MainMenuBarMaxLevelBar:SetWidth(512);
    ReputationWatchStatusBar:SetWidth(512);

	MainMenuBarPerformanceBarFrame:ClearAllPoints();
    MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", KeyRingButton, "BOTTOMLEFT", 2, -11);
    KeyRingButton:ClearAllPoints();
    KeyRingButton:SetPoint("BOTTOMRIGHT", CharacterBag3Slot, "BOTTOMLEFT", -5, -2);
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("BOTTOMRIGHT", WorldFrame, "BOTTOMRIGHT", -185, 45);
    MainMenuBarBackpackButton:ClearAllPoints();
    MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", WorldFrame, "BOTTOMRIGHT", -5, 5);
    MainMenuXPBarTexture0:SetPoint("BOTTOM", "MainMenuExpBar", "BOTTOM", -128, 2);
    MainMenuXPBarTexture1:SetPoint("BOTTOM", "MainMenuExpBar", "BOTTOM", 128, 3);
    MainMenuMaxLevelBar0:SetPoint("BOTTOM", "MainMenuBarMaxLevelBar", "TOP", -128, 0);
    MainMenuBarTexture0:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -128, 0);
    MainMenuBarTexture1:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 128, 0);
    MainMenuBarLeftEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -290, 0);
    MainMenuBarRightEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 287, 0);
    
    if self.db.account.bags == true then
        self:ShowBags();
    else
        self:HideBags();
    end
    
    if self.db.account.menu == true then
        self:ShowMenu();
    else
        self:HideMenu();
    end
    
    if self.db.account.gryphons == true then
        self:ShowGryphons();
    else
        self:HideGryphons();
    end
	
	if self.db.account.latency == true then
		self:ShowLatency();
	else
		self:HideLatency();
	end
end

function SimpleBar:UIParent_ManageFramePositions()
	SlidingActionBarTexture0:Hide();
	SlidingActionBarTexture1:Hide();
	ShapeshiftBarLeft:Hide();
	ShapeshiftBarMiddle:Hide();
	ShapeshiftBarRight:Hide();
	PossessBarLeft:Hide();
	PossessBarRight:Hide();
    
    barsOffset = 5;
    stanceBarOffset = 5;
    castBarOffset = 0;
    barsAnchor = MainMenuBar
    stanceBarAnchor = MainMenuBar;
    castBarAnchor = "MainMenuBar";

    if ReputationWatchBar:IsShown() then
        barsAnchor = ReputationWatchBar;
    elseif MainMenuExpBar:IsShown() then
        barsAnchor = MainMenuExpBar;
    end
    
    if MultiBarBottomLeft:IsShown() then
        stanceBarAnchor = MultiBarBottomLeft;
    elseif MultiBarBottomRight:IsShown() then
        stanceBarAnchor = MultiBarBottomRight;
    end

    if MultiBarBottomLeft:IsShown() and MultiBarBottomRight:IsShown() then
        self:MoveBottomLeft(barsAnchor, 2, barsOffset);
        self:MoveBottomRight(MultiBarBottomLeft, 0, barsOffset);
        castBarAnchor = "MultiBarBottomRight";
        stanceBarAnchor = MultiBarBottomRight;
    elseif MultiBarBottomLeft:IsShown() then
        self:MoveBottomLeft(barsAnchor, 2, barsOffset);
        castBarAnchor = "MultiBarBottomLeft";
    elseif MultiBarBottomRight:IsShown() then
        self:MoveBottomRight(barsAnchor, 2, barsOffset);
        castBarAnchor = "MultiBarBottomRight";
    else
        stanceBarOffset = 14;
    end
    
    if PetActionBarFrame:IsShown() then
        self:MovePetBar(stanceBarAnchor, 5, stanceBarOffset);
        castBarAnchor = "PetActionBarFrame";
    elseif ShapeshiftBarFrame:IsShown() then
        self:MoveStanceBar(stanceBarAnchor, 5, stanceBarOffset);
        castBarAnchor = "ShapeshiftBarFrame";
    elseif PossessBarFrame:IsShown() then
        self:MovePossesBar(stanceBarAnchor, 5, stanceBarOffset);
        castBarAnchor = "PossessBarFrame";
    end
    
    if castBarAnchor == "MainMenuBar" then
        castBarOffset = 25;
    else
        castBarOffset = 15;
    end 
    
    CastingBarFrame:SetPoint("CENTER", castBarAnchor, "TOP", 0, castBarOffset);
end

function SimpleBar:MoveBottomLeft(attach, x, y)
	MultiBarBottomLeft:ClearAllPoints();
	MultiBarBottomLeft:SetPoint("BOTTOM", attach, "TOP", x, y);
end

function SimpleBar:MoveBottomRight(attach, x, y)
	MultiBarBottomRight:ClearAllPoints();
	MultiBarBottomRight:SetPoint("BOTTOM", attach, "TOP", x, y);
end

function SimpleBar:MovePetBar(attach, x, y)
	UIPARENT_MANAGED_FRAME_POSITIONS["PetActionBarFrame"] = nil;
	PetActionBarFrame:ClearAllPoints();
	PetActionBarFrame:SetPoint("BOTTOMLEFT", attach, "TOPLEFT", x, y);
end

function SimpleBar:MoveStanceBar(attach, x, y)
	UIPARENT_MANAGED_FRAME_POSITIONS["ShapeshiftBarFrame"] = nil;
	ShapeshiftBarFrame:ClearAllPoints();
	ShapeshiftButton1:SetPoint("BOTTOMLEFT", attach, "TOPLEFT", x, y);
end

function SimpleBar:MovePossesBar(attach, x, y)
	UIPARENT_MANAGED_FRAME_POSITIONS["PossessBarFrame"] = nil;
	PossessBarFrame:ClearAllPoints();
	PossessBarFrame:SetPoint("BOTTOMLEFT", attach, "TOPLEFT", x, y);
end